<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 2.8: Increment and Decrement Operators</title>
<link href="sx5g.html" rev=precedes>
<link href="sx5i.html" rel=precedes>
<link href="sx5.html" rev=subdocument>
</head>
<body>
<H2>section 2.8: Increment and Decrement Operators</H2>

<p>The distinction between the prefix and postfix forms of 
<TT>++</TT> and <TT>--</TT>
will probably
seem strained at first,
but it will make more sense once we begin using these operators 
in more realistic situations.
</p><p>The authors point out that an expression like <TT>(i+j)++</TT> is illegal,
and it's
worth thinking for a moment about <em>why</em>.
The <TT>++</TT> operator doesn't just mean ``add one'';
it means ``add one <em>to a variable</em>''
or ``make a variable's value one more than it was before.''
But <TT>(i+j)</TT> is not a variable,
it's an expression;
so there's no place for <TT>++</TT> to store the incremented result.
If you were bound and determined to use <TT>++</TT> here,
you'd have to introduce another variable:
<pre>	int k = i + j;
	k++;
</pre>But really,
when you want to add one to an expression, just use
<pre>	i + j + 1
</pre></p><p>Another unfortunate
(and utterly meaningless)
example is
<pre>	i = i++;
</pre>If you want to increment <TT>i</TT>
(that is,
add one to it,
and store the result back in <TT>i</TT>),
either use
<pre>	i = i + 1;
</pre>or
<pre>	i++;
</pre>Don't try to combine the two.
</p><p>page 47
</p><p>Deep sentence:
<blockquote>In a context where no value is wanted,
just the incrementing effect,
as in
<pre>	if(c == '\n')
		nl++;
</pre>prefix and postfix are the same.
</blockquote>In other words,
when you're just incrementing some variable,
you can use either the <TT>nl++</TT> or <TT>++nl</TT> form.
But when you're immediately using the result,
as in the examples
we'll look at later,
using one or the other makes a big difference.
</p><p>In that light,
study
one of the examples on this page--<TT>squeeze</TT>,
the modified <TT>getline</TT>,
or <TT>strcat</TT>--and convince yourself that it would
<em>not</em> work if the wrong form of increment
(<TT>++i</TT> or <TT>++j</TT>)
were used.
</p><p>You may note that all three examples
on pages 47-48
use the postfix form.
Postfix increment is probably more common,
though prefix definitely has its uses, too.
</p><p>You may notice the keyword <TT>void</TT> popping up in a few code examples.
<TT>void</TT> is a type we haven't met yet;
it's a type with no values and no operations.
When a function is declared as ``returning'' <TT>void</TT>,
as in the <TT>squeeze</TT> and <TT>strcat</TT> examples
on pages 47 and 48,
it means that the function does not return a value.
(This was briefly mentioned on page 30 in chapter 1.)

</p><hr>
<p>
Read sequentially:
<a href="sx5g.html" rev=precedes>prev</a>
<a href="sx5i.html" rel=precedes>next</a>
<a href="sx5.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
